<!--
  ~ (c) Copyright 2024 Swiss Post Ltd.
  ~
  ~ Licensed under the Apache License, Version 2.0 (the "License");
  ~ you may not use this file except in compliance with the License.
  ~ You may obtain a copy of the License at
  ~
  ~    http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~ Unless required by applicable law or agreed to in writing, software
  ~ distributed under the License is distributed on an "AS IS" BASIS,
  ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  ~ See the License for the specific language governing permissions and
  ~ limitations under the License.
  -->
<div class="container-fluid">
  <div class="row m-1">
    <div class="col-12 p-1 m-1 text-center">
      <h1 class="display-1">Swiss Post Verifier</h1>
    </div>
  </div>
  <div class="row m-1 mb-3">
    <div class="col-12 p-0">
      <div class="h-100 p-3 bg-white rounded shadow">
        <div class="row">
          <div class="col-12">
            <h2 class="display-2 mb-3">Verification datasets</h2>
          </div>
        </div>
        <app-verifier-mode
          (newVerifierMode)="setNewVerifierMode($event)"
          [changeModeDisabled]="actionsDisabled()"
          [triggerModal]="contextFilename !== undefined && contextFilename !== ''"
          [verifierMode]="verifierMode"
        ></app-verifier-mode>
        <app-upload
          (datasetConfiguration)="setDatasetConfigurationContext($event)"
          (uploadingDataset)="uploadingDatasetContextReset($event)"
          *ngIf="verifierMode"
          [datasetType]="getDatasetTypeContext()"
          [uploadDisabled]="actionsDisabled()"
          [verifierMode]="verifierMode"
        ></app-upload>
        <app-upload
          (datasetConfiguration)="setDatasetConfiguration($event)"
          (uploadingDataset)="uploadingDatasetReset($event)"
          *ngIf="contextFilename && verifierMode"
          [datasetType]="getDatasetType()"
          [uploadDisabled]="actionsDisabled()"
        ></app-upload>
        <div *ngIf="contextFilename" class="row mt-4">
          <div class="col-12 mb-2">
            <div class="row">
              <div class="col-12">
                <div class="form-check form-switch float-left">
                  <input [(ngModel)]="displayDatasetInformation" class="form-check-input" id="toggleDatasetInformationSwitch" role="switch" type="checkbox">
                  <label class="form-check-label" for="toggleDatasetInformationSwitch">Display Dataset Information</label>
                </div>
              </div>
            </div>
            <app-dataset-information
              [configuration]="configuration"
              [displayDatasetInformation]="displayDatasetInformation"
              [verifierMode]="verifierMode"
            ></app-dataset-information>
          </div>
        </div>
        <div *ngIf="contextFilename && verifierMode" class="row mb-2 mt-2">
          <div class="col-2 btn-group btn-block">
            <button (click)="startVerification()" [disabled]="uploadingDataset || startDisabled"
                    class="btn btn-primary" type="button">
              <i aria-hidden="true" class="bi-caret-right-fill"></i> Verify
            </button>
            <button (click)="resetProcess()" [disabled]="!isProcessComplete()" class="btn btn-outline-primary" type="button">
              <i aria-hidden="true" class="bi-arrow-counterclockwise"></i> Reset
            </button>
          </div>
          <div class="col-7 font-weight-bold mt-2 text-right">
            Status
          </div>
          <div class="col-3 mt-2">
            <div *ngIf="!processStarted">
              Verification not run
            </div>
            <div *ngIf="processStarted && !isProcessComplete()">
              <div class="spinner-border spinner-border-sm text-primary" role="status">
                <span class="visually-hidden">In progress...</span>
              </div>
              Verification in progress...
            </div>
            <div *ngIf="processStarted && isProcessComplete()">
              <i aria-hidden="true" class="bi-check-circle text-success"></i> Verification completed
            </div>
          </div>
        </div>
        <div *ngIf="processStarted" class="row mt-3">
          <hr>
          <div class="col-12">
            <div class="float-left">
              <button (click)="filterVerificationsRUNNING()" [class.active]="verificationFilter.RUNNING.active"
                      class="btn btn-outline-primary mr-1 mt-1" type="button">
                Running <span class="badge text-bg-light">{{statusCounterRUNNING()}}</span>
              </button>
              <button (click)="filterVerificationsOK()" [class.active]="verificationFilter.OK.active" class="btn btn-outline-success mr-1 mt-1"
                      type="button">
                Success <span class="badge text-bg-light">{{statusCounterOK()}}</span>
              </button>
              <button (click)="filterVerificationsNOK()" [class.active]="verificationFilter.NOK.active" class="btn btn-outline-danger mr-1 mt-1"
                      type="button">
                Failure <span class="badge text-bg-light">{{statusCounterNOK()}}</span>
              </button>
              <button (click)="filterVerificationsERROR()" [class.active]="verificationFilter.ERROR.active" class="btn btn-outline-warning mr-1 mt-1"
                      type="button">
                Error <span class="badge text-bg-light">{{statusCounterERROR()}}</span>
              </button>
            </div>
            <div class="form-check ml-4 mt-2 pt-1 float-left">
              <input [(ngModel)]="toggleMessage" class="form-check-input" id="toggleMessageSwitch" type="checkbox">
              <label class="form-check-label" for="toggleMessageSwitch">Display failure/error messages</label>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>

  <div *ngIf="processStarted" class="row m-1" id="verification-report">
    <div class="col-12 p-3 mb-3 bg-white rounded shadow">
      <div class="row">
        <div class="col-9">
          <h2 class="display-2 mb-3">Verification report</h2>
        </div>
        <div class="col-3" data-html2canvas-ignore>
          <button (click)="exportToPDF()" [disabled]="!printMode || isExportingToPDF" class="btn btn-primary ml-3">
            <span *ngIf="isExportingToPDF" aria-hidden="true" class="spinner-grow spinner-grow-sm" role="status"></span>
            <i *ngIf="!isExportingToPDF" aria-hidden="true" class="bi-printer"></i> Print to PDF
          </button>
          <div class="form-check form-switch float-right ml-3 mt-2">
            <input [(ngModel)]="printMode" class="form-check-input" id="togglePrintModeSwitch" role="switch" type="checkbox">
            <label class="form-check-label" for="togglePrintModeSwitch">Print mode</label>
          </div>
        </div>
      </div>
      <app-dataset-information
        [configuration]="configuration"
        [displayDatasetInformation]="printMode"
        [endDate]="endDate"
        [startDate]="startDate"
        [statusCounterERROR]="statusCounterERROR()"
        [statusCounterNOK]="statusCounterNOK()"
        [statusCounterOK]="statusCounterOK()"
        [totalNumberOfSetupVerifications]="totalNumberOfSetupVerifications"
        [totalNumberOfTallyVerifications]="totalNumberOfTallyVerifications"
        [verifierMode]="verifierMode"
      ></app-dataset-information>
      <app-report-details
        [toggleMessage]="toggleMessage"
        [verificationStatusFilter]="verificationStatusFilter"
        [verifications]="verifications"
      ></app-report-details>

      <div *ngIf="printMode" class="row html2pdf-break-page html2pdf-no-break">
        <div class="col-12 mt-5 mb-3 font-weight-bold">
          VERIFICATION CONFIRMATION
          <hr>
        </div>
        <div class="col-12">
          <h4>The signers hereby confirm that they verified the correctness of the above information</h4>
        </div>
        <div class="col-12 m-4">
          <div class="row">
            <div class="col-2 font-weight-bold">Name</div>
            <div class="col-3"></div>
            <div class="col-2 font-weight-bold">Signature</div>
            <div class="col-5"></div>
          </div>
          <div class="row mt-5 mb-5">
            <div class="col-2 font-weight-bold">Name</div>
            <div class="col-3"></div>
            <div class="col-2 font-weight-bold">Signature</div>
            <div class="col-5"></div>
          </div>
        </div>
      </div>
    </div>
  </div>
</div>
